require "TSLib"
local ts = require("ts")--使用苏泽库前必须插入这一句
local json = ts.json;

wipeking = {}

function apiHttpGet(paramStr)
	local value = httpGet("http://127.0.0.1:8181/api?"..paramStr);
	--toast("http 请求返回值："..tostring(value),1)
	return value;
end 

--日志--
function myLog(message)
	--sysLog(message);
end	

---一键清理-7001---
function wipeking.cleanDevice()
	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7001";   

	--请求一键清理
	result_dotask_json = apiHttpGet(reqParamStr);
 
	--无响应
	if (result_dotask_json==false) then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
		--清理接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json) ;
	end

	--每4秒请求一次任务结果      
	local result_getstatus_json;
	local result_getstatus_table;  
	local i = 0;      
	while (i<=20) do
		reqParamStr = "reqCode=7011&taskId="..result_dotask_table["Data"]["TaskId"];
		myLog(reqParamStr);

		result_getstatus_json = apiHttpGet(reqParamStr);
		myLog(result_getstatus_json);
		--插件无响应
		if (result_getstatus_json == "") then 
			result_getstatus_table["RespCode"] = "-1";
			result_getstatus_table["Message"] ="抹机王无响应，请求超时";             
			return result_getstatus_table;
			--插件有响应
		else            
			myLog("插件有响应");
			result_getstatus_table = json.decode(result_getstatus_json);
			if (result_getstatus_table["RespCode"] == "2") then                     
				myLog("一键清理运行中");
				mSleep(4000);
				i = i + 1;
			else 
				myLog ("一键清理结果出来了");
				--执行结果已出来
				return result_getstatus_table;
			end 
		end
	end

	--60次还在运行中，被脚本当成超时处理
	if (result_getstatus_table["RespCode"] == "2") then
		result_getstatus_table["RespCode"] = "-1";
		result_getstatus_table["Message"] = "任务长时间未结束，已当超时处理";
		return result_getstatus_table;
	end

end

---一键还原-7002---
function wipeking.envRestore(configDir)

	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7002&configDir="..configDir;

	--请求一键还原
	result_dotask_json = apiHttpGet(reqParamStr);  
	--还原无响应
	if result_dotask_json==false then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
		--还原接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json);       
	end

    --如果已有任务在进行，返回-1
    if (result_dotask_table["RespCode"] == "-1")  then 
       return result_dotask_table;
	end  

	--每4秒请求一次任务结果      
	local result_getstatus_json;
	local result_getstatus_table={};
	local i = 0;
	while (i<=20) do
		reqParamStr = "reqCode=7011&taskId="..result_dotask_table["Data"]["TaskId"];   
		result_getstatus_json = apiHttpGet(reqParamStr); 
		--插件无响应
		if result_getstatus_json == "" then
			result_getstatus_table["RespCode"] = "-1";
			result_getstatus_table["Message"] ="抹机王无响应，请求超时";
			return result_getstatus_table;              
			--插件有响应
		else 
			myLog("插件有响应");
			result_getstatus_table = json.decode(result_getstatus_json);    
			--正在执行中
			if  (result_getstatus_table["RespCode"]== "2") then
				myLog("任务正在运行"); 
				mSleep(4000);
				i=i+1;
				--执行结果已出来
			else                  
				return result_getstatus_table;
			end              
		end
	end   

	--while次循环后还在运行中，被脚本当成超时处理
	if result_getstatus_table["RespCode"] == "2" then
		result_getstatus_table["RespCode"] = "-1";
		result_getstatus_table["Message"] = "任务长时间未结束，已当超时处理";  
		return result_getstatus_table;
	end

end

--一键备份环境数据-7003--
function wipeking.backupDevice()
	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7003";   

	--请求备份
	result_dotask_json = apiHttpGet(reqParamStr);

	--无响应
	if (result_dotask_json==false) then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
		--备份接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json);
	end


	--每4秒请求一次任务结果      
	local result_getstatus_json;
	local result_getstatus_table;  
	local i = 0;      
	while (i<=20) do
		reqParamStr = "reqCode=7011&taskId="..result_dotask_table["Data"]["TaskId"];
		myLog(reqParamStr);

		result_getstatus_json = apiHttpGet(reqParamStr);
		myLog(result_getstatus_json);
		--插件无响应
		if (result_getstatus_json == "") then 
			result_getstatus_table["RespCode"] = "-1";
			result_getstatus_table["Message"] ="抹机王无响应，请求超时";             
			return result_getstatus_table;
			--插件有响应
		else            
			myLog("插件有响应");
			result_getstatus_table = json.decode(result_getstatus_json);
			if (result_getstatus_table["RespCode"] == "2") then                     
				myLog("备份运行中");
				mSleep(4000);
				i = i + 1;
			else 
				myLog ("备份结果出来了");
				--执行结果已出来
				return result_getstatus_table;
			end 
		end
	end

	--60次还在运行中，被脚本当成超时处理
	if (result_getstatus_table["RespCode"] == "2") then
		result_getstatus_table["RespCode"] = "-1";
		result_getstatus_table["Message"] = "任务长时间未结束，已当超时处理";
		return result_getstatus_table;
	end

end

--一键还原上个环境-7004--
function wipeking.upRestore()
	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7004";   

	--请求操作
	result_dotask_json = apiHttpGet(reqParamStr);
    
	--无响应
	if (result_dotask_json==false) then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
		--接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json) ;
	end

    --如果已有任务在进行，返回-1
    if (result_dotask_table["RespCode"] == "-1")  then 
       return result_dotask_table;
	end  

	--每4秒请求一次任务结果      
	local result_getstatus_json;
	local result_getstatus_table;  
	local i = 0;      
	while (i<=20) do
		reqParamStr = "reqCode=7011&taskId="..result_dotask_table["Data"]["TaskId"];
		myLog(reqParamStr);

		result_getstatus_json = apiHttpGet(reqParamStr);
		myLog(result_getstatus_json);
		--插件无响应
		if (result_getstatus_json == "") then 
			result_getstatus_table["RespCode"] = "-1";
			result_getstatus_table["Message"] ="抹机王无响应，请求超时";             
			return result_getstatus_table;
			--插件有响应
		else            
			myLog("插件有响应");
			result_getstatus_table = json.decode(result_getstatus_json);
			if (result_getstatus_table["RespCode"] == "2") then                     
				myLog("还原上个环境运行中");
				mSleep(4000);
				i = i + 1;
			else 
				myLog ("还原上个环境结果出来了");
				--执行结果已出来
				return result_getstatus_table;
			end 
		end
	end

	--60次还在运行中，被脚本当成超时处理
	if (result_getstatus_table["RespCode"] == "2") then
		result_getstatus_table["RespCode"] = "-1";
		result_getstatus_table["Message"] = "任务长时间未结束，已当超时处理";
		return result_getstatus_table;
	end

end

--一键还原下个环境-7005--
function wipeking.downRestore()
	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7005";   

	--请求操作
	result_dotask_json = apiHttpGet(reqParamStr);

	--无响应
	if (result_dotask_json==false) then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
		--接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json) ;
	end

    --如果已有任务在进行，返回-1
    if (result_dotask_table["RespCode"] == "-1")  then 
       return result_dotask_table;
	end  

	--每4秒请求一次任务结果      
	local result_getstatus_json;
	local result_getstatus_table;  
	local i = 0;      
	while (i<=20) do
		reqParamStr = "reqCode=7011&taskId="..result_dotask_table["Data"]["TaskId"];
		myLog(reqParamStr);

		result_getstatus_json = apiHttpGet(reqParamStr);
		myLog(result_getstatus_json);
		--插件无响应
		if (result_getstatus_json == "") then 
			result_getstatus_table["RespCode"] = "-1";
			result_getstatus_table["Message"] ="抹机王无响应，请求超时";             
			return result_getstatus_table;
			--插件有响应
		else            
			myLog("插件有响应");
			result_getstatus_table = json.decode(result_getstatus_json);
			if (result_getstatus_table["RespCode"] == "2") then                     
				myLog("还原下个环境运行中");
				mSleep(4000);
				i = i + 1;
			else 
				myLog ("还原下个环境结果出来了");
				--执行结果已出来
				return result_getstatus_table;
			end 
		end
	end

	--60次还在运行中，被脚本当成超时处理
	if (result_getstatus_table["RespCode"] == "2") then
		result_getstatus_table["RespCode"] = "-1";
		result_getstatus_table["Message"] = "任务长时间未结束，已当超时处理";
		return result_getstatus_table;
	end

end

--一键还原至第1个或最后一个环境-7006--
function wipeking.TopRestore(firstOrLast)
	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7006&firstOrLast="..firstOrLast;   

	--请求操作
	result_dotask_json = apiHttpGet(reqParamStr);

	--无响应
	if (result_dotask_json==false) then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
		--接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json) ;
	end

    --如果已有任务在进行，返回-1
    if (result_dotask_table["RespCode"] == "-1")  then 
       return result_dotask_table;
	end  

	--每4秒请求一次任务结果      
	local result_getstatus_json;
	local result_getstatus_table;  
	local i = 0;      
	while (i<=20) do
		reqParamStr = "reqCode=7011&taskId="..result_dotask_table["Data"]["TaskId"];
		myLog(reqParamStr);

		result_getstatus_json = apiHttpGet(reqParamStr);
		myLog(result_getstatus_json);
		--插件无响应
		if (result_getstatus_json == "") then 
			result_getstatus_table["RespCode"] = "-1";
			result_getstatus_table["Message"] ="抹机王无响应，请求超时";             
			return result_getstatus_table;
			--插件有响应
		else            
			myLog("插件有响应");
			result_getstatus_table = json.decode(result_getstatus_json);
			if (result_getstatus_table["RespCode"] == "2") then                     
				myLog("还原下个环境运行中");
				mSleep(4000);
				i = i + 1;
			else 
				myLog ("还原下个环境结果出来了");
				--执行结果已出来
				return result_getstatus_table;
			end 
		end
	end

	--60次还在运行中，被脚本当成超时处理
	if (result_getstatus_table["RespCode"] == "2") then
		result_getstatus_table["RespCode"] = "-1";
		result_getstatus_table["Message"] = "任务长时间未结束，已当超时处理";
		return result_getstatus_table;
	end

end

--获取当前环境路径-7012--
function wipeking.pathQuery()
	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7012";   

	--请求获取
	result_dotask_json = apiHttpGet(reqParamStr);
    
	--无响应
	if (result_dotask_json==false) then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
		--接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json) ;
		
	end
	return result_dotask_table;
end

--当前备份环境记录查询-7013--
function wipeking.recordQuery(configName)
	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7013&configName="..configName;   

	--请求获取
	result_dotask_json = apiHttpGet(reqParamStr);
    
	--无响应
	if (result_dotask_json==false) then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
		--接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json);
		
	end
	return result_dotask_table;
end

--修改环境名称-7014--
function wipeking.setNeedname(configName,updateConfigName)
	local result_json;
	local result_table={};
	local reqParamStr = "reqCode=7014&configName="..configName.."&updateConfigName="..updateConfigName;

	result_json = apiHttpGet(reqParamStr);  
	--无响应
	if result_json==false then          
		result_table["RespCode"] = "-1";
		result_table["Message"] ="抹机王无响应，请求超时";
		--接口有响应
	else
		result_table = json.decode(result_json);  
        		
	end
	return result_table;
end

--删除环境-7015--
function wipeking.delConfig(configDirs)
	local result_json;
	local result_table={};
	local reqParamStr = "reqCode=7015&configName="..configDirs;

	--请求备份
	result_json = apiHttpGet(reqParamStr);  
	--无响应
	if result_json==false then          
		result_table["RespCode"] = "-1";
		result_table["Message"] ="抹机王无响应，请求超时";
		--接口有响应
	else
		result_table = json.decode(result_json);    
		
	end  
	return result_table;
end

-- 清理无备份的环境包-7016 --
function wipeking.ClearRecord(lastSevenDay)
	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7016&lastSevenDay="..lastSevenDay;  

	--请求操作
	result_dotask_json = apiHttpGet(reqParamStr);
 
	--无响应
	if (result_dotask_json==false) then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
	--接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json) ;
	end


	--每4秒请求一次任务结果      
	local result_getstatus_json;
	local result_getstatus_table;  
	local i = 0;      
	while (i<=40) do
		reqParamStr = "reqCode=7011&taskId="..result_dotask_table["Data"]["TaskId"];
		myLog(reqParamStr);

		result_getstatus_json = apiHttpGet(reqParamStr);
		myLog(result_getstatus_json);
		--插件无响应
		if (result_getstatus_json == "") then 
			result_getstatus_table["RespCode"] = "-1";
			result_getstatus_table["Message"] ="抹机王无响应，请求超时";             
			return result_getstatus_table;
			--插件有响应
		else            
			myLog("插件有响应");
			result_getstatus_table = json.decode(result_getstatus_json);
			if (result_getstatus_table["RespCode"] == "2") then                     
				myLog("清理环境包运行中");
				mSleep(4000);
				i = i + 1;
			else 
				myLog ("清理环境包结果出来了");
				--执行结果已出来
				return result_getstatus_table;
			end 
		end
	end

	--60次还在运行中，被脚本当成超时处理
	if (result_getstatus_table["RespCode"] == "2") then
		result_getstatus_table["RespCode"] = "-1";
		result_getstatus_table["Message"] = "任务长时间未结束，已当超时处理";
		return result_getstatus_table;
	end

end

--查看当前环境设备信息-7017--
function wipeking.currentRecordQuery()
	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7017";   

	--请求获取
	result_dotask_json = apiHttpGet(reqParamStr);
    
	--无响应
	if (result_dotask_json==false) then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
		--接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json) ;
		
	end
	return result_dotask_table;
end

--_删除当前环境-7018--
function wipeking.delCurrentRecord()
	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7018";   

	--请求获取
	result_dotask_json = apiHttpGet(reqParamStr);
    
	--无响应
	if (result_dotask_json==false) then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
		--接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json);
		
	end
	return result_dotask_table;
end

--修改当前环境名-7019--
function wipeking.setCurrentRecord(configName)
	local result_dotask_json;
	local result_dotask_table={};
	local reqParamStr = "reqCode=7019&configName="..configName;   

	--请求获取
	result_dotask_json = apiHttpGet(reqParamStr);
    
	--无响应
	if (result_dotask_json==false) then          
		result_dotask_table["RespCode"] = "-1";
		result_dotask_table["Message"] ="抹机王无响应，请求超时";
		return result_dotask_table;
		--接口有响应
	else
		result_dotask_table = json.decode(result_dotask_json);
		
	end
	return result_dotask_table;
end

---环境备份名设置-7021---
function wipeking.setEnvBackupConfigName(configName)
	local result_json;
	local result_table={};
	local reqParamStr = "reqCode=7021&configName="..configName;

	--请求备份
	result_json = apiHttpGet(reqParamStr);  
	--无响应
	if result_json==false then          
		result_table["RespCode"] = "-1";
		result_table["Message"] ="抹机王无响应，请求超时";
		--接口有响应
	else
		result_table = json.decode(result_json);    
	end  
	
    return result_table;
end

---添加需清理的应用-7022---
function wipeking.setNeedWipeApp(pkgName,type)
	local result_json;
	local result_table={};
	local reqParamStr = "reqCode=7022&pkgName="..pkgName.."&type="..type;

	result_json = apiHttpGet(reqParamStr);  
	--无响应
	if result_json==false then          
		result_table["RespCode"] = "-1";
		result_table["Message"] ="抹机王无响应，请求超时";
		--接口有响应
	else
		result_table = json.decode(result_json);    
	end  
	
    return result_table;
end

---设置自定义IMEI-7024---
function wipeking.setCustomImei(mode,imei,addType)
	local result_json;
	local result_table={};
	local reqParamStr = "reqCode=7024&mode"..mode.."&imei="..imei.."&addType="..addType;

	result_json = apiHttpGet(reqParamStr);  
	--无响应
	if result_json==false then          
		result_table["RespCode"] = "-1";
		result_table["Message"] ="抹机王无响应，请求超时";
		--接口有响应
	else
		result_table = json.decode(result_json);    
	end  
	
    return result_table;
end

---运行沙盒内应用-7031---
function wipeking.RunWipeApp(pkgName)
	local result_json;
	local result_table={};
	local reqParamStr = "reqCode=7031&pkgName="..pkgName;

	result_json = apiHttpGet(reqParamStr);  
	--无响应
	if result_json==false then          
		result_table["RespCode"] = "-1";
		result_table["Message"] ="抹机王无响应，请求超时";
		--接口有响应
	else
		result_table = json.decode(result_json);    
	end  
	
    return result_table;
end

---退出模拟器安全模式-7032---
function wipeking.setQuitSafeMode()
	local result_json;
	local result_table={};
	local reqParamStr = "reqCode=7032";

	result_json = apiHttpGet(reqParamStr);  
	--无响应
	if result_json==false then          
		result_table["RespCode"] = "-1";
		result_table["Message"] ="抹机王无响应，请求超时";
		--接口有响应
	else
		result_table = json.decode(result_json);    
	end  
	
    return result_table;
end

---压缩文件-5005---
function wipeking.ZipFile(filePath,zipPath)
	local result_json;
	local result_table={};
	local reqParamStr = "reqCode=5005&filePath="..filePath.."&zipPath="..zipPath;

	result_json = apiHttpGet(reqParamStr);  
	--无响应
	if result_json==false then          
		result_table["RespCode"] = "-1";
		result_table["Message"] ="抹机王无响应，请求超时";
		--接口有响应
	else
		result_table = json.decode(result_json);    
	end  
	
    return result_table;
end


---解压文件-5006---
function wipeking.UnzipFile(zipPath,unZipPath)
	local result_json;
	local result_table={};
	local reqParamStr = "reqCode=5006&zipPath="..zipPath.."&unZipPath="..unZipPath;

	result_json = apiHttpGet(reqParamStr);  
	--无响应
	if result_json==false then          
		result_table["RespCode"] = "-1";
		result_table["Message"] ="抹机王无响应，请求超时";
		--接口有响应
	else
		result_table = json.decode(result_json);    
	end  
	
    return result_table;
end

---上传ftp文件-5007---
function wipeking.FtpFile(ftpIp,ftpPort,account,password,localPath,ftpPath)
	local result_json;
	local result_table={};
	local reqParamStr = "reqCode=5007&ftpIp="..ftpIp.."&ftpPort="..ftpPort.."&account="..account.."&password="..password.."&localPath="..localPath.."&ftpPath="..ftpPath;

	result_json = apiHttpGet(reqParamStr);  
	--无响应
	if result_json==false then          
		result_table["RespCode"] = "-1";
		result_table["Message"] ="抹机王无响应，请求超时";
		--接口有响应
	else
		result_table = json.decode(result_json);    
	end  
	
    return result_table;
end

---下载ftp文件-5008---
function wipeking.DownFile(ftpIp,ftpPort,account,password,ftpPath,localPath)
	local result_json;
	local result_table={};
	local reqParamStr = "reqCode=5008&ftpIp="..ftpIp.."&ftpPort="..ftpPort.."&account="..account.."&password="..password.."&ftpPath="..ftpPath.."&localPath="..localPath;

	result_json = apiHttpGet(reqParamStr);  
	--无响应
	if result_json==false then          
		result_table["RespCode"] = "-1";
		result_table["Message"] ="抹机王无响应，请求超时";
		--接口有响应
	else
		result_table = json.decode(result_json);    
	end  
	
    return result_table;
end



return wipeking;